// netTerm.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include <stdio.h>      /* for printf(), fprintf() */
#include <winsock.h>    /* for socket(),... */
#include <stdlib.h>     /* for exit() */

#define MAXPENDING 5    /* Maximum outstanding connection requests */
#define RCVBUFSIZE 64   /* Size of receive buffer */

/*
 *  ubN̒`
 */
typedef struct netblock {
    unsigned char  command;
    unsigned char  size;
    unsigned char  sub;
    unsigned char  dmy;
    unsigned long  cnt;
    unsigned long  arg1;
    union{
       unsigned long  w;
       unsigned short h[2];
       unsigned char  b[4];
    }arg2;
} NETBLOCK;

#define	NETDEVICE_READ	1
#define	NETDEVICE_WRITE	2
#define	NETDEVICE_INT   3
#define	NETDEVICE_DATA  10
#define	NETDEVICE_COMMAND_MASK	0x1f;

extern "C" void InitializeComSupportModuleN(int * clntSock);
extern "C" void FinalizeComSupportModuleN(void);
extern "C" int DeviceRead(unsigned long address, unsigned long size, void * storage);
extern "C" int DeviceWrite(unsigned long address, unsigned long size, void * storage);
static bool HandlenetDeviceClient(int clntSocket);   /* netDevice client handling function */
static void *HandlenetDeviceSend(void *arg);         /* netDevice send to client program of a thread */
static void EnterSendLock(bool * lock);	/* Send NetBlock Lock function */
static void LeaveSendLock(bool * lock);	/* Send NetBlock Unlock funtion */
static void netDeviceError(char *errorMessage);	/* handling error */

static HANDLE sendMutex = NULL;		    /* Send Mutex */
static DWORD  sendMutexOwner = 0;		/* Send Mutex Owner */
static unsigned long net_count = 0;		/* network counter */
static int clntSock = -1;               /* Socket descriptor for client */
static bool check_connect = FALSE;

int main(int argc, char* argv[])
{
    HANDLE threadHandle;                /* Thread Handle from CreateThread() */
    struct sockaddr_in netServAddr;		/* netDevice server address */
	char ips[20];
	unsigned char ipx[4];
    WSADATA wsaData;                    /* Structure for WinSock setup communication */

	if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0){ /* Load Winsock 2.0 DLL */
        fprintf(stderr, "WSAStartup() failed");
        return(1);
    }
	sendMutex = CreateMutex(NULL,TRUE,NULL);
	ReleaseMutex(sendMutex);
	for(;;){
        memset(&netServAddr, 0, sizeof(netServAddr));   /* initial netDevice structure */
        netServAddr.sin_family      = AF_INET;          /* Internet address family */
        netServAddr.sin_port        = htons(49150);     /* Server port */

	    /* IPAhX̐ݒ */
	    printf("Input IP address = ");
	    scanf("%s", ips);
        netServAddr.sin_addr.s_addr = inet_addr(ips);	/* Server IP address */
		if(strlen(ips) < 9){
			if(ips[0] > 'q'){
				printf("\n");
				continue;
			}
			printf("exit (%s)\n", ips);
			break;
		}
		ipx[0] = (unsigned char)(netServAddr.sin_addr.s_addr & 0xff);
	    ipx[1] = (unsigned char)((netServAddr.sin_addr.s_addr>>8) & 0xff);
	    ipx[2] = (unsigned char)((netServAddr.sin_addr.s_addr>>16) & 0xff);
	    ipx[3] = (unsigned char)((netServAddr.sin_addr.s_addr>>24) & 0xff);
	    printf("(%02x.%02x.%02x.%02x)\n", ipx[0], ipx[1], ipx[2], ipx[3]);
		if ((threadHandle = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) HandlenetDeviceSend, 
              0, 0, 0)) == NULL)
            netDeviceError("pthread_create() failed");
		/* WinSock̃\Pbg */
        if ((clntSock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
            netDeviceError("socket() failed");
	    /* T[oփRlNV̐ݒ */
        if (connect(clntSock, (struct sockaddr *) &netServAddr, sizeof(netServAddr)) < 0)
            netDeviceError("connect() failed");

        printf("Connect netDevice Server!\n");
        InitializeComSupportModuleN(&clntSock);
		check_connect = TRUE;
        HandlenetDeviceClient(clntSock);
		check_connect = FALSE;
        FinalizeComSupportModuleN();
        printf("Disconnect netDevice Server!\n");
        closesocket(clntSock);
        CloseHandle(threadHandle);
        clntSock = -1;
    }
	CloseHandle(sendMutex);
	WSACleanup();  /* Cleanup Winsock */
	return 0;
}

void SendInterruptMsg(int inhno)
{
	NETBLOCK ibuf;
	int sendMsgSize;
	bool iLock;

	if(clntSock == -1)
		return;
	EnterSendLock(&iLock);
    ibuf.command = NETDEVICE_INT;
    ibuf.size    = sizeof(NETBLOCK);
    ibuf.sub     = 0;
	ibuf.cnt     = htonl(++net_count);
	ibuf.arg1    = htonl(inhno);
	sendMsgSize  = send(clntSock, (char *)&ibuf, sizeof(NETBLOCK), 0);
	LeaveSendLock(&iLock);

}

static bool HandlenetDeviceClient(int clntSocket)
{
	NETBLOCK *pnet;
    char echoBuffer[RCVBUFSIZE];        /* Buffer for echo string */
	char rbuf[RCVBUFSIZE];
    int recvMsgSize;                    /* Size of received message */
	int sendMsgSize;
	unsigned long address;
	int i, roff, cmd;
	bool pLock;
	char *b;

    /* Receive message from client */
	roff = 0;
	pnet = (NETBLOCK *)rbuf;
    if ((recvMsgSize = recv(clntSocket, echoBuffer, RCVBUFSIZE, 0)) < 0){
	    fprintf(stderr,"recv(): %d\n", WSAGetLastError());
		return FALSE;
	}

    /* Send received string and receive again until end of transmission */
    while (recvMsgSize > 0)      /* zero indicates end of transmission */
    {
		for(i = 0 ; recvMsgSize > 0 ; recvMsgSize--){
			b = rbuf + roff;
			*b = echoBuffer[i++];
			roff++;
			if(roff >= sizeof(NETBLOCK) && roff >= pnet->size){
				address = ntohl(pnet->arg1);
				cmd = pnet->command & NETDEVICE_COMMAND_MASK;
				if(cmd == NETDEVICE_READ){
					DeviceRead(address, pnet->sub, (void *)&pnet->arg2);
					if(pnet->sub == 2)
						pnet->arg2.h[0] = htons(pnet->arg2.h[0]);
					else if(pnet->sub == 4)
						pnet->arg2.w = htonl(pnet->arg2.w);
					EnterSendLock(&pLock);
					pnet->command = (pnet->command & 0x1f) | 0x20;
					pnet->cnt = htonl(++net_count);
					sendMsgSize = send(clntSocket, rbuf, pnet->size, 0);
					LeaveSendLock(&pLock);
					if(sendMsgSize != pnet->size){
					    fprintf(stderr,"send(): %d\n", WSAGetLastError());
						return FALSE;
					}
				}
				else if(cmd == NETDEVICE_WRITE){
					if(pnet->sub == 2)
						pnet->arg2.h[0] = htons(pnet->arg2.h[0]);
					else if(pnet->sub == 4)
						pnet->arg2.w = htonl(pnet->arg2.w);
					DeviceWrite(address, pnet->sub, (void *)&pnet->arg2);
					EnterSendLock(&pLock);
					pnet->command = (pnet->command & 0x1f) | 0x20;
					pnet->cnt = htonl(++net_count);
					sendMsgSize = send(clntSocket, rbuf, pnet->size, 0);
					LeaveSendLock(&pLock);
					if(sendMsgSize != sizeof(NETBLOCK)){
					    fprintf(stderr,"send(): %d\n", WSAGetLastError());
						return FALSE;
					}
				}
				else if(cmd == NETDEVICE_DATA){
					int no;
					b = (char *)&pnet->arg1;
					for(no = 0 ; no < pnet->sub ; no++)
						putchar(*b++);
				}
				roff = 0;
			}
		}
        /* See if there is more data to receive */
        if ((recvMsgSize = recv(clntSocket, echoBuffer, RCVBUFSIZE,0)) < 0){
		    fprintf(stderr,"recv(): %d\n", WSAGetLastError());
			return FALSE;
		}
	}
	return TRUE;
}

void *HandlenetDeviceSend(void *arg)
{
	NETBLOCK cbuf;
	int sendMsgSize, len;
	bool cLock;
	char *b;

	b = (char *)&cbuf.arg1;
    for(len = 0 ; len >= 0 ;){
        b[len++] = getchar();
		if(check_connect){
			if(b[0] == 'Q' || b[0] == 'q'){
				b[0] = 1;
				len = 1;
			}
			if(len >= 8 || b[len-1] == 0x0a || b[0] == 1){
				EnterSendLock(&cLock);
		        cbuf.command   = NETDEVICE_DATA;
			    cbuf.size      = sizeof(NETBLOCK);
			    cbuf.sub       = len;
		        cbuf.cnt       = htonl(++net_count);
				if(clntSock != -1){
					sendMsgSize  = send(clntSock, (char *)&cbuf, sizeof(NETBLOCK), 0);
					if(sendMsgSize != sizeof(NETBLOCK)){
						fprintf(stderr,"send(): %d\n", WSAGetLastError());
						len = -1;
						break;
					}
				}
				LeaveSendLock(&cLock);
				len = 0;
			}
			if(b[0] == 1)
				break;
		}
		else
			len = 0;
	}
	printf("exit command thread !!\n");
    return (NULL);
}

static void EnterSendLock(bool * lock)
{
	if(sendMutex != NULL && sendMutexOwner != GetCurrentThreadId()){
		WaitForSingleObject(sendMutex, INFINITE);
		*lock = TRUE;
		sendMutexOwner = GetCurrentThreadId();
	}
	else{
		*lock = FALSE;
	}
}

static void LeaveSendLock(bool *lock)
{
	if(*lock == TRUE){
		sendMutexOwner = 0;
		if(sendMutex != NULL)
			ReleaseMutex(sendMutex);
	}
}

static void netDeviceError(char *errorMessage)
{
    fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
	CloseHandle(sendMutex);
    exit(1);
}
