#include <t_services.h>
#include "kernel_id.h"

#include "cup_timer.h"
#include "device.h"

/*
 *  O[oϐ
 */ 
CONDITION sw4;
CONDITION sw1;

/*
 * ^C}[^XNp̃tÕrbg蓖
 */ 
#define TIMER_SW1_ON    0x01
#define TIMER_SW1_OFF   0x02
#define TIMER_SW4_ON    0x04
#define TIMER_BASE_TIME 0x08
#define TIMER_ALL       0x0f

/*
 * uN^XNp̃tÕrbg蓖
 */ 
#define BLINK_ACTIVE  0x01
#define BLINK_TIMEOUT 0x02
#define BLINK_BLINK   0x04
#define BLINK_OFF     0x08
#define BLINK_ALL     0x0f


/*
 * ^C}[^XN
 */ 
void
timer_task(VP_INT exinf)
{
    int timer;
    FLGPTN flgptn;
    
    for (;;) {
        timer = 0;
        do {
            wai_flg(FLG_TIMER, TIMER_ALL, TWF_ORW, &flgptn);
            if ((flgptn & TIMER_SW1_ON) != 0) {
                timer = INIT_TIME;
                syslog_0(LOG_NOTICE, "Timer start!");
            }
            if ((flgptn & TIMER_SW1_OFF) != 0) {
                set_flg(FLG_BLINK, BLINK_OFF);
                syslog_0(LOG_NOTICE, "Timer stop!");
            }
        } while (timer == 0);

        sta_cyc(BASE_TIME_HANDLER);
        while (timer > 0) {
            wai_flg(FLG_TIMER, TIMER_ALL, TWF_ORW, &flgptn);
            if ((flgptn & TIMER_SW1_OFF) != 0) {
                set_flg(FLG_BLINK, BLINK_OFF);
                timer = 0;
            }
            else {
                if ((flgptn & TIMER_SW4_ON) != 0) {
                    timer = timer + EXTRA_UNIT;
                    syslog_2(LOG_NOTICE, "Extend %d sec. Remaining  %d sec",
                             EXTRA_UNIT, timer);
                }
                if ((flgptn & TIMER_BASE_TIME) != 0) {
                    timer = timer - 1;
                    if (timer == 0) {
                        set_flg(FLG_BLINK, BLINK_TIMEOUT);
                        syslog_0(LOG_NOTICE, "Timer timeout");
                    }
                    else if ((timer % ACT_INTERVAL) == 0) {
                        set_flg(FLG_BLINK, BLINK_ACTIVE);
                        syslog_1(LOG_NOTICE, "Remaining  %d sec", timer);

                    }
                }
            }
        }
        stp_cyc(BASE_TIME_HANDLER);
    }
}


/*
 *  LED2_Ń^XN
 */
void
blink_task(VP_INT exinf)
{
    int bcount;
    FLGPTN flgptn;
    CONDITION sta_led = OFF;
    
    for (;;) {
        bcount = 0;
        do {
            wai_flg(FLG_BLINK, BLINK_ALL, TWF_ORW, &flgptn);
            if ((flgptn & BLINK_ACTIVE) != 0) {
                bcount = ACT_BLINK_TIME;
            }
            if ((flgptn & BLINK_TIMEOUT) != 0) {
                bcount = TIMEOUT_BLINK;
            }
        } while (bcount == 0);

        sta_cyc(LED2_BLINK_TIME_HANDLER);
        while (bcount > 0) {
            wai_flg(FLG_BLINK, BLINK_ALL, TWF_ORW, &flgptn);
            if ((flgptn & BLINK_BLINK) != 0) {
                if(sta_led == ON)
                    sta_led = OFF;
                else
                    sta_led = ON;
                set_led(LED2, sta_led);
                bcount--;
            }
            if ((flgptn & BLINK_OFF) != 0) {
                bcount = 0;
            }
        }
        stp_cyc(LED2_BLINK_TIME_HANDLER);
    }
}


/*
 *  [`
 */ 
void
init_cup_timer(VP_INT exinf)
{
    initial_switch();      /* XCb`̏ */
    initial_led();         /* LED̏ */

    sw4 = get_switch(SW4); /* ݂SW4̎荞 */
    sw1 = get_switch(SW1); /* ݂SW1̎荞 */
}


/*
 *  LED1_Ŏnh
 */ 
void
led1_blink_handler(void){
    static CONDITION sta_led = OFF;

    if (sta_led == ON) {
        sta_led = OFF;
    } else {
        sta_led = ON;
    }
    
    set_led(LED1, sta_led);
}


/*
 * LED2_ŎԐnh
 */
void
led2_blink_time_handler(void){
    syscall(iset_flg(FLG_BLINK, BLINK_BLINK));
}


/*
 * XCb`ԃXLnh
 */
void
sw_scan_handler(void){
    CONDITION sw;
    FLGPTN   flgptn = 0;

    sw = get_switch(SW1);
    if (sw1 != sw) {
        if (sw == ON) {
          flgptn |= TIMER_SW1_ON;
        } else {
          flgptn |= TIMER_SW1_OFF;
        }
        sw1 = sw;
    }
    
    sw = get_switch(SW4);
    if (sw4 != sw) {
        if (sw == ON)
          flgptn |= TIMER_SW4_ON;
        sw4 = sw;
    }
    
    if (flgptn != 0x00)
      syscall(iset_flg(FLG_TIMER, flgptn));
}


/*
 * {Ԑnh
 */
void
base_time_handler(void){
    syscall(iset_flg(FLG_TIMER, TIMER_BASE_TIME));
}
