#include <s_services.h>
#include "device.h"

/*
 * LEDڑ|[g
 *  LED1 : |[g4̃rbg6ɐڑ
 *  LED2 : |[g4̃rbg7ɐڑ
 *
 * |[g48rbgoX[hŃ|[gLƂȂD
 * oXABWCR(0xee020)oXRg[WX^Őݒ
 * ̃WX^̃rbg'1'ɐݒ肷ƑΉGÃANZX[h8rbg
 * ƂȂD 
 */
#define ABWCR 0xfee020
#define P4DDR 0xfee003
#define P4DR  0xffffd3

#define P4DDR_B6 0x40
#define P4DDR_B7 0x80

/*
 *  LED̐ݒԂۑϐ
 */ 
volatile static unsigned char cled;

/*
 * LEDڑ|[g̏
 */ 
void
initial_led()
{
	cled = 0x00;
	/* 8rbgoX[h */
	sil_wrb_mem((VP)ABWCR,0xff);
	/* P4̃rbg6ƃrbg7o̓|[g */
	sil_wrb_mem((VP)P4DDR, (P4DDR_B6 | P4DDR_B7));
	/* P4̏o̓f[^(Ԃ͏) */
	sil_wrb_mem((VP)P4DR,sil_reb_mem((VP)P4DR) & ~(P4DDR_B6|P4DDR_B7));
}


/*
 * LEDڑ|[g
 */ 
void
led_out(unsigned char led_data)
{
	sil_wrb_mem((VP)P4DR,
				sil_reb_mem((VP)P4DR) & ~(P4DDR_B6 | P4DDR_B7)
				|(led_data & (P4DDR_B6 | P4DDR_B7)));	
}


/*
 * LED̐ݒs
 *  arg1 : LED1܂LE3
 *  arg2 : ON܂OFF 
 */ 
void
set_led(LED led, CONDITION req)
{
	unsigned char rled = cled;

	switch(led){
	  case LED1:
		if (req == OFF)
		  rled &= ~P4DDR_B6;
		else
		  rled |= P4DDR_B6;
		break;
	  case LED2:
		if (req == OFF)
		  rled &= ~P4DDR_B7;
		else
		  rled |= P4DDR_B7;			
		break;
	  default:
		break;
	}

	
	if (cled != rled) {
		cled = rled;
		led_out(cled);
	}
}


/*
 * DIPXCb`ڑ|[g
 *  DIP1 : |[g5̃rbg0ɐڑ
 *  DIP2 : |[g5̃rbg1ɐڑ
 *  DIP3 : |[g5̃rbg2ɐڑ
 *  DIP4 : |[g5̃rbg3ɐڑ
 *
 *  |[g5P5DDR̉4rbg'0'ɐݒ肷Ɠ̓|[gƂėLɂȂ
 *  ܂A|[g5֘ÃWX^̏4rbg̓U[urbgł邽߁C
 *  ݓǂݍ݂͖łD̂߁C}XN̕Kv͂ȂD
 */ 


#define P5DDR 0xfee004
#define P5DR  0xffffd4
#define P5PCR 0xfee03f

#define P5DR_B0 0x01
#define P5DR_B1 0x02
#define P5DR_B2 0x04
#define P5DR_B3 0x08

#define P5PCR_PULLUP 0x0f

/*
 *  XCb`̏֐
 */ 
void
initial_switch()
{
	/* o̓|[g */
	sil_wrb_mem((VP)P5DDR, 0x00);
	/* PULL UP*/
	sil_wrb_mem((VP)P5PCR, P5PCR_PULLUP);
}

/*
 *  XCb`̏Ԏ擾
 */ 
unsigned char
sense_switch(void)
{
	return(sil_reb_mem((VP)(P5DR))&(P5DR_B0|P5DR_B1|P5DR_B2|P5DR_B3));
}


/*
 *  XCb`̏Ԃo
 *  arg1:SW1,SW2,SW3,SW4
 */
CONDITION
get_switch(SWITCH sw)
{
    unsigned char    key;
    CONDITION result = OFF;

    key = sense_switch();
    
    switch(sw){
    case SW1:
        if((key & P5DR_B0) == 0)
            result = ON;
        break;
    case SW2:
        if((key & P5DR_B1) == 0)
            result = ON;
        break;
    case SW3:
        if((key & P5DR_B2) == 0)
            result = ON;
        break;
    case SW4:
        if((key & P5DR_B3) == 0)
            result = ON;
        break;		
    default:
        break;
    }
    return result;
}

