/* 
 *  TCPGR[T[o[
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <net/net_timer.h>

#include "tcp_srv.h"

/*
 *  O֐̒`
 */

extern const char *itron_strerror (ER ercd);

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  MEChEobt@TCY + MEChEobt@TCY
 *  傫Ȃ΁AfbhbN\B
 */

#define BUF_SIZE	2048 * 3


/*
 *  TCP Mobt@
 */

UB tcp_srv_cep_sbuf[TCP_SRV_CEP_SBUF_SIZE];
UB tcp_srv_cep_rbuf[TCP_SRV_CEP_RBUF_SIZE];

/*
 * Mobt@
 */
static UB 		rbuffer[BUF_SIZE];
static UB       sbuffer[BUF_SIZE];

void
tcp_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	ID tskid;
	T_IPEP		dst; 
	ER	error = E_OK;
	char	c;
	int	slen, spoint, slen_remain;
	int rlen;
	int i;
	char sdata;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP SRV :%d,%d] started.", tskid, (INT)exinf);

	while(TRUE){
		if (tcp_acp_cep(TCP_SRV_CEPID, TCP_SRV_REPID, &dst, TMO_FEVR) != E_OK){
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", TCP_SRV_CEPID, itron_strerror(error));
			continue;
		}
		ip2str(addr, &dst.ipaddr);
		get_tim(&now);
		
		syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d", TCP_SRV_CEPID, now / SYSTIM_HZ, addr, dst.portno);

		while (TRUE) {
			if ((rlen = tcp_rcv_dat(TCP_SRV_CEPID, rbuffer, BUF_SIZE - 1, TMO_FEVR)) <= 0) {
				if (rlen != E_OK)
					syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s",
						   TCP_SRV_CEPID, itron_strerror(rlen));
				break;
			}

			rbuffer[rlen] = '\0';
			syslog(LOG_NOTICE, "Recive Data %s", rbuffer);

			for(i = 0; i < rlen; i++){
				if(rbuffer[i] >= ' ')
					sbuffer[i] = rbuffer[i] + 1;
				else
					sbuffer[i] = rbuffer[i];
			}
			sbuffer[rlen] = '\0';

			syslog(LOG_NOTICE, "Send Data %s", sbuffer);

			slen_remain = rlen;
			spoint = 0;
			do{
				if ((slen = tcp_snd_dat(TCP_SRV_CEPID, &sbuffer[spoint], slen_remain, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s", TCP_SRV_CEPID, itron_strerror(slen));
					goto err_fin;
				}
				spoint += slen;
				slen_remain -= slen;
			}while(slen_remain > 0);
		}
		
	err_fin:
		if ((error = tcp_cls_cep(TCP_SRV_CEPID, TMO_FEVR)) != E_OK)
		  syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s", TCP_SRV_CEPID, itron_strerror(error));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d",
			   TCP_SRV_CEPID, now / SYSTIM_HZ);
	}
}
