/* 
 *  TCP}`^XNT[o[
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <net/net_timer.h>

#include "tcp_srv.h"
#include "device.h"

/*
 *  O֐̒`
 */

extern const char *itron_strerror (ER ercd);

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  MEChEobt@TCY + MEChEobt@TCY
 *  傫Ȃ΁AfbhbN\B
 */

#define BUF_SIZE	2048 * 3


/*
 *  TCP Mobt@
 */

UB tcp_srv_cep_sbuf1[TCP_SRV_CEP_SBUF_SIZE];
UB tcp_srv_cep_rbuf1[TCP_SRV_CEP_RBUF_SIZE];
UB tcp_srv_cep_sbuf2[TCP_SRV_CEP_SBUF_SIZE];
UB tcp_srv_cep_rbuf2[TCP_SRV_CEP_RBUF_SIZE];

/*
 * Mobt@
 */
static UB 		rbuffer[2][BUF_SIZE];
static UB 		sbuffer[2][BUF_SIZE];


/*
 * ʐM[_̏擾
 */
int tcp_cep_id[] = {TCP_SRV_CEPID1, TCP_SRV_CEPID2};


/*
 * foCX[`
 */ 
void
device_init(VP_INT exinf)
{
	initial_switch();      /* XCb`̏ */
    initial_led();         /* LED̏ */
}

void
led_control(char c)
{
	switch(c){
	  case '0':
		set_led(LED1,OFF);
		set_led(LED2,OFF);
		break;
	  case '1':
		set_led(LED1,ON);
		set_led(LED2,OFF);
		break;
	  case '2':
		set_led(LED1,OFF);
		set_led(LED2,ON);
		break;
	  case '3':
		set_led(LED1,ON);
		set_led(LED2,ON);
		break;
	  default:
		break;
	}
}


int
dip_monitor(char *buffer)
{
	buffer[0] = '\n';
	buffer[1] = '\r';
	
	if (get_switch(SW1) == ON) {
		buffer[2] = '1';
	}else{
		buffer[2] = '0';
	}		
	if (get_switch(SW2)  == ON) {
		buffer[3] = '1';
	}else{
		buffer[3] = '0';
	}
	if (get_switch(SW3) == ON) {
		buffer[4] = '1';
	}else{
		buffer[4] = '0';
	}
	if (get_switch(SW4) == ON) {
		buffer[5] = '1';
	}else{
		buffer[5] = '0';
	}

	buffer[6] = '\0';

	syslog(LOG_NOTICE, "Dip state is %s", buffer);
	return 6;
}


void
tcp_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	ID tskid;	
	T_IPEP		dst;
	ER	error = E_OK;
	char	c;
	int	slen, spoint, slen_remain;
	int rlen;
	SYSTIM	now;
	INT  cepid;

	cepid = tcp_cep_id[(INT)exinf];

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP SRV :%d,%d] started.", tskid, (INT)exinf);

	while(TRUE){
		if (tcp_acp_cep(cepid, TCP_SRV_REPID, &dst, TMO_FEVR) != E_OK){
			syslog(LOG_NOTICE, "[TES:%02d ACP] error: %s", cepid, itron_strerror(error));
			continue;
		}
		ip2str(addr, &dst.ipaddr);
		get_tim(&now);
		
		syslog(LOG_NOTICE, "[TES:%02d ACP] connected:  %6d, from: %s.%d", cepid, now / SYSTIM_HZ, addr, dst.portno);

		while (TRUE) {
			if ((rlen = tcp_rcv_dat(cepid, rbuffer[(INT)exinf], BUF_SIZE - 1, TMO_FEVR)) <= 0) {
				if (rlen != E_OK)
					syslog(LOG_NOTICE, "[TES:%02d RCV] error: %s",
						   cepid, itron_strerror(rlen));
				break;
			}

			rbuffer[(INT)exinf][rlen] = '\0';
			syslog(LOG_NOTICE, "Recive Data %s", rbuffer[(INT)exinf]);

			/* LED̑ */
			led_control(rbuffer[(INT)exinf][0]);

			/* DIPԂ̎擾 */
			slen_remain = dip_monitor(sbuffer[(INT)exinf]);
			spoint = 0;

			while(slen_remain > 0){
				if ((slen = tcp_snd_dat(cepid, &sbuffer[(INT)exinf][spoint], slen_remain, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TES:%02d SND] error: %s", cepid, itron_strerror(slen));
					goto err_fin;
				}
				slen_remain -= slen;
				spoint += slen;
			}
		}
		
	err_fin:
		if ((error = tcp_cls_cep(cepid, TMO_FEVR)) != E_OK)
		  syslog(LOG_NOTICE, "[TES:%02d CLS] error: %s", cepid, itron_strerror(error));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d FIN] finished:   %6d",
			   cepid, now / SYSTIM_HZ);
	}
}
