/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Platform Development Center
 *                              RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: akih8pot_device.c,v 1.2 2006/05/27 09:21:20 roi Exp $
 */

#include <t_services.h>
#include <t_config.h>
#include <string.h>
#include <monsil.h>
#include "akih8pot_device.h"
#include "kernel_id.h"

#define	REG_SIM_TIME	0xFEEF00

#define	P4ID	0
#define	P7ID	1

/*
 *  A/DRo[^[h(P:134Xe[g:AN4P)
 */
#define	ADINIT	(CSR_CKS|4)


/*
 * LCD̊֐
 */
extern void lcd_init(void);
extern void lcd_out8(UB c);
extern void lcd_out4(UB d);
extern void lcd_rs_bit(INT state);

static void display_lcd(UB no, B * p);

static unsigned char const led_table[NUM_LED-1][2] = {
	P4ID, P4_LEDBOIL,		/* BOIL */
	P4ID, P4_KEEPWARM,		/* KEEPWARM */
	P7ID, P7_LEDHIGH,		/* HIGH */
	P7ID, P7_LEDECO,		/* ECO */
	P7ID, P7_LEDMILK,		/* MILK */
	P7ID, P7_LEDLOCK		/* LOCK */
};
static unsigned char const ctl_table[NUM_CTL] = {
	PA_CNTPUMP,				/* PUMP */
	PA_CNTLOCK,				/* LOCK */
	PA_CNTHEATER,			/* HEATER */
	PA_CNTHEATPWR,			/* HEATPOWER */
	PA_CNTBUZZER			/* BUZZER */
};

static char const raddec[] = "0123456789";
static UB lcdbuf[32];
static UB akih8_p7;
static UB akih8_pa;
static H  old_temp = -500;
static UH old_level = -1;

UB akih8_cled;

/*
 *  j^[̋N̗LԂ
 */
BOOL
need_monitor()
{
	if(!(sil_reb_mem((VP)H8P5DR) & P5_DIP1))
		return TRUE;
	else{
		act_tsk(TIMER_TASK);
		return FALSE;
	}
}

/*
 *  POTn[hEFȀ֐
 */
void
initial_pot()
{
					/* LED̏ */
	akih8_cled  = 0xff;
	akih8_cled &= ~(P4_LEDBOIL|P4_KEEPWARM);
	sil_wrb_mem((VP)H8P4DR, akih8_cled);	/* |[g4f[^ */
					/* LCD̃Zbg */
	lcd_init();
	memset(lcdbuf, ' ', sizeof(lcdbuf));
	display_lcd(2, lcdbuf);
	akih8_p7 = 0x00;
	sil_wrb_mem((VP)H8P7DR, akih8_p7);		/* |[g7f[^ */
	sil_wrb_mem((VP)H8PADR, akih8_pa);		/* |[gAf[^ */
	sil_wrb_mem((VP)H8ADCSR, ADINIT);		/* A/DRo[g */
}

/*
 *  XCb`̏Ԃo
 */
int
get_switch()
{
	return ~sil_reb_mem((VP)H8PBDR);
}

/*
 *  |bg̉x̎荞(xx8)
 */
int
get_temp()
{
	unsigned int temp1;
	int temp;

											/* A/DϊX^[g */
	sil_wrb_mem((VP)H8ADCSR, ADINIT|CSR_ADST);
											/* ϊI҂ */
	while((sil_reb_mem((VP)H8ADCSR) & CSR_ADF) == 0);
	temp1 = sil_reb_mem((VP)H8ADDRAH) << 8;	/* f[^̎o */
	temp1 |= sil_reb_mem((VP)H8ADDRAL);
	sil_wrb_mem((VP)H8ADCSR, ADINIT);		/* NAtO */
	temp = (temp1 - 8740) >> 2;			/* x(x8)ɕϊ */

	return temp;
}

/*
 *  |bg̐ʂ̎荞
 */
int
get_level()
{
	int level;

	level = ~sil_reb_mem((VP)H8P2DR) & P2_SLEVEL;
	return level >> 3;
}

/*
 *  LED̐ݒs
 *  arg1:PotLedID
 *  arg2:ONAOFF܂͐
 */
void
set_led(PotLedID led, int req)
{
	UB rled;

	switch(led){
	case LED_LEVEL:
		rled = (akih8_p7 & ~P7_LEDLEVEL) | (req & P7_LEDLEVEL);
		if(rled != akih8_p7){
			akih8_p7 = rled;
			sil_wrb_mem((VP)H8P7DR, akih8_p7);
		}
		break;
	default:
		if(led_table[led][0] == P4ID){
			rled = akih8_cled;
			if(req == ON)
				rled |= led_table[led][1];
			else
				rled &= ~led_table[led][1];
			if(rled != akih8_cled){
				akih8_cled = rled;
				sil_wrb_mem((VP)H8P4DR, akih8_cled);
			}
		}
		else if(led_table[led][0] == P7ID){
			rled = akih8_p7;
			if(req == ON)
				rled |= led_table[led][1];
			else
				rled &= ~led_table[led][1];
			if(rled != akih8_p7){
				akih8_p7 = rled;
				sil_wrb_mem((VP)H8P7DR, akih8_p7);
			}
		}
		break;
	}
}

/*
 *  |bg̐s
 *  arg1:PotCtlID
 *  arg2:ON܂OFF
 */
void
set_control(PotCtlID id, int req)
{
	UB rctl;

	rctl = akih8_pa;
	if(req == ON)
		rctl |= ctl_table[id];
	else
		rctl &= ~ctl_table[id];
	if(rctl != akih8_pa){
		akih8_pa = rctl;
		sil_wrb_mem((VP)H8PADR, akih8_pa);
	}
}

/*
 * x\s
 * arg1:temperature
 * arg2:water level
 */
void
display_temp(H temp, UH level)
{
	int i;

	if(old_temp == temp && old_level == level)
		return;

	memset(&lcdbuf[0], ' ', 16);
	old_temp  = temp;
	old_level = level;
	if(temp > 120)
		temp = 120;
	if(temp < -20)
		temp = -20;

	if(level > 15){
		lcdbuf[0] = 'F';
		lcdbuf[1] = 'U';
		lcdbuf[2] = lcdbuf[3] = 'L';
	}
	else{
		lcdbuf[0] = 'L';
		lcdbuf[1] = 'V';
		lcdbuf[2] = 'L';
		for(i = 3 ; i >= 0 ; i--){
			if(level & (1<<i))
				lcdbuf[4+(3-i)] = 0xff;
		}
	}
	lcdbuf[9]  = 'T';
	lcdbuf[10] = 'M';
	lcdbuf[11] = 'P';

	if(temp < 0){
		lcdbuf[13] = '-';
		temp = -temp;
	}
	i = 15;
	do {
		lcdbuf[i--] = raddec[temp % 10];
		temp /= 10;
	} while (temp != 0);
	display_lcd(0, lcdbuf);
}

/*
 * ^C}[̏Ԃ\
 * arg1:^C}[c莞
 */
void
display_time(UW time)
{
	int min, sec;
	int i;

	memset(&lcdbuf[16], ' ', 16);
	if(time != 0){							/* ON̐ݒ */
		lcdbuf[16] = 'T';
		lcdbuf[17] = 'i';
		lcdbuf[18] = 'm';
		lcdbuf[19] = 'e';
		lcdbuf[20] = 'r';
		min = time / 60;
		sec = time % 60;

		i = 16+12;
		do {
			lcdbuf[i--] = raddec[min % 10];
			min /= 10;
		} while (min != 0);

		i = 16+13;
		lcdbuf[i++] = ':';
		lcdbuf[i++] = raddec[sec/10];
		lcdbuf[i++] = raddec[sec%10];
	}
	display_lcd(1, &lcdbuf[16]);
}

/*
 *  LCD\
 */
static B *
display_line(B * p)
{
	int i;

	for(i = 0 ; i < 16 ; i++){
		lcd_rs_bit(ON);
		lcd_out4(*p++);
		lcd_rs_bit(OFF);
	}
	return p;
}

static void
display_lcd(UB no, B * p)
{
	wai_sem(SEM_DISPLAY);
	lcd_rs_bit(OFF);						/* J[\[z[ */
	lcd_out4(0x02);
	sil_dly_nse(DCNT_FNC);

	if(no != 1){							/* 1sڕ\ */
		p = display_line(p);
	}

	if(no > 0){
		lcd_rs_bit(OFF);					/* z[2s */
		lcd_out4(0xc0);
		sil_dly_nse(DCNT_FNC);
		p = display_line(p);				/* 2sڕ\ */
	}
	sig_sem(SEM_DISPLAY);
}

/*
 * V~[V(100ms)o
 */
unsigned long
get_simtime()
{
	unsigned long simtime;

	simtime = (UB)sil_reb_mem((VP)REG_SIM_TIME) << 24;
	simtime |= (UB)sil_reb_mem((VP)REG_SIM_TIME+1) << 16;
	simtime |= (UB)sil_reb_mem((VP)REG_SIM_TIME+2) << 8;
	return simtime | (UB)sil_reb_mem((VP)REG_SIM_TIME+3);
}

