/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Platform Development Center
 *                              RICOH COMPANY,LTD. JAPAN
 *
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: potti.c,v 1.1 2004/10/02 19:30:20 roi Exp $
 */

/* 
 *  TOPPERSp̋ރvO
 *  SESSAMEub蕦|bg(GOMA-1015^)vdlFRŁv
 *  b蕦|bg̋@\B
 *  s́AH8-3069FRg[JSP+TINETA
 *  LAN+netDeviceoRāADeviceManager̘b蕦|bgV~[^
 *  (H8-3069F)ł𐧌䂷邱ƂɂvdlB
 * ydlύXz
 *  ̐ȉɂāA@\̐A܂́AdlύXB
 *  1)엦pq[^̐́Apx̊荞ݑKvƂ邽
 *    {ł̓T|[gA엦100%܂0%̐̂ݍsB
 *  2)xƃ^C}[̕\̓V~[^ɑ΂ẮAs킸H8-3069Fg{[h
 *    ̂kbcɑ΂ĕ\ŝƂB
 *    kbc̃CAEg16X2słAJ҂RɃCAEg
 *    \ėǂ
 * y񎖍z
 *  netDevice̐A|[g̃ANZX͔^XNReLXgł͍sȂD
 *
 */

#include <t_services.h>
#include "kernel_id.h"
#include "akih8pot_device.h"
#include "potti.h"

/*
 *  ^C}^XN̏
 */
typedef enum timer_state {
	STATE_STOP_TIMER,			/* ^C}[~ */
	STATE_ACT_TIMER				/* ^C}[s */
} TIMER_STATE;

unsigned char potstate;

/*
 * {^݃nh[
 */
void
button_int_handler(void)
{
	iset_flg(EVT_FLGID, EVT_BUTTON);
	/* 񂠂FȊÕItCxg𔭍sȂ悤ɂ */
}

/*
 * Jo[荞݃nh[
 */
void
cover_int_handler(void)
{
	iset_flg(EVT_FLGID, EVT_COVER);
}

/*
 *  ^C}p^XNFN^XN
 */
void
timer_task(VP_INT exinf)
{
	SYSTIM      current_time;
	SYSTIM      start_time, last_time;
	SYSTIM      show_time, buzzer_time;
	TMO         tmout = TMO_FEVR;
	TIMER_STATE state = STATE_STOP_TIMER;
	ER          ercd;
	FLGPTN      flgptn;

#ifdef S_DEBUG
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
#endif
	syslog(LOG_INFO, "Pot timer task starts (exinf = %d).", exinf);
	initial_pot();					/* POT̏ */
	buzzer_time = 0;
	clr_flg(TIM_FLGID, 0);
	act_tsk(HEATER_TASK);			/* q[^[^XN̋N */
	act_tsk(ERROR_TASK);			/* G[^XN̋N */
	act_tsk(EVENT_TASK);			/* Cxg^XN̋N */
	for(;;){
		ercd = twai_flg(TIM_FLGID, EVT_TIME, TWF_ORW, &flgptn, tmout);
		current_time = get_simtime();	/* ݎԂ̎o */
		if(ercd == E_OK){	/* entry_taskʒm */
			clr_flg(TIM_FLGID, ~flgptn);
			if(flgptn & TIM_SWITCH){		/* ^C}[L[ */
				if(state == STATE_STOP_TIMER){
					state = STATE_ACT_TIMER;
					start_time = current_time;
					last_time = start_time + 60*S_1SEC;
					show_time = current_time + S_1SEC;
					syslog(LOG_INFO, "Timer Start !");
				}
				else{
					last_time += 60*S_1SEC;
					syslog(LOG_INFO, "Timer Count Up !");
				}
				buzzer_time = current_time + S_1SEC;
			}
			if(flgptn & TIM_1SEC_BUZZER)	/* 1buU[v */
				buzzer_time = current_time + S_1SEC;
			if(flgptn & TIM_30SEC_BUZZER)	/* 30buU[v */
				buzzer_time = current_time + 30*S_1SEC;
		}
		if(buzzer_time > 0){
			if(buzzer_time <= current_time){
				buzzer_time = 0;
				set_control(CTL_BUZZER, OFF);
			}
			else{
				if((((buzzer_time - current_time) / 5) & 1)
						|| ((buzzer_time - current_time) % 10) == 0)
					set_control(CTL_BUZZER, ON);
				else
					set_control(CTL_BUZZER, OFF);
			}
		}

		switch(state){			/* ^C}[Ԃ̔ */
		case STATE_ACT_TIMER:	/* ^C}[s */
			if(last_time <= current_time){
				state = STATE_STOP_TIMER;
				buzzer_time = current_time + 3*S_1SEC;
				set_control(CTL_BUZZER, ON);
				display_time(0);
			}
			else if(show_time <= current_time){
				display_time((last_time-show_time)/10);
				do{
					show_time += S_1SEC;
				}while(show_time <= current_time);
			}
			tmout = S_TICK * 100;
			break;
		default:				/* ^C}[~ */
			if(buzzer_time > 0)
				tmout = S_TICK * 100;
			else
				tmout = TMO_FEVR;
			break;
		}
	}
}

/*
 *  Cxg^XNFC
 */
void
event_task(VP_INT exinf)
{
	ER      ercd;
	FLGPTN  flgptn;
	UB      event, sw, oldlevel;
	H       oldtemp;
	int     mode;

	syslog(LOG_INFO, "Pot event task starts (exinf = %d).", exinf);
	event = sw = get_switch();		/* BUTTON̏Ԃ̎o */
	potstate = HIGH_MODE|PUMP_LOCK;	/* STATȄ */
	set_led(LED_HIGH, ON);			/* ԂLED̓_ */
	set_led(LED_LOCK, ON);
	clr_flg(EVT_FLGID, 0);			/* tÕNA */

	for(;;){
		ercd = wai_flg(EVT_FLGID, EVT_EVENT, TWF_ORW, &flgptn);
		if(ercd == E_OK){	/* button_taskʒm */
			event = get_switch();
			clr_flg(EVT_FLGID, ~flgptn);
			if(flgptn & EVT_BUTTON){
									/* ^C}[{^ */
				if((event & BUTTON_TIMER) && !(sw & BUTTON_TIMER)){
					syslog(LOG_INFO, "TIMER BOTTON !");
					set_flg(TIM_FLGID, TIM_SWITCH);
					set_flg(TIM_FLGID, TIM_1SEC_BUZZER);
				}
									/* [h{^ */
				if((event & BUTTON_MODE) && !(sw & BUTTON_MODE)){
					mode = (potstate + 1) & MODE_MASK;
					if(mode == 0)
						mode = HIGH_MODE;
					potstate = (potstate & ~MODE_MASK) | mode;
					switch(mode){
					case ECO_MODE:
						set_led(LED_HIGH, OFF);
						set_led(LED_ECO, ON);
						set_led(LED_MILK, OFF);
						break;
					case MILK_MODE:
						set_led(LED_HIGH, OFF);
						set_led(LED_ECO, OFF);
						set_led(LED_MILK, ON);
						break;
					default:
						set_led(LED_HIGH, ON);
						set_led(LED_ECO, OFF);
						set_led(LED_MILK, OFF);
						break;
					}
					syslog(LOG_INFO, "HEAT_CHECK !");
					set_flg(TIM_FLGID, TIM_1SEC_BUZZER);
					set_flg(HEAT_FLGID, HEAT_CHECK);
				}
									/* {^ */
				if((event & BUTTON_UNLOCK) && !(sw & BUTTON_UNLOCK)
							&& !(potstate & PUMP_ACT)){
					if(potstate & PUMP_LOCK){
						potstate &= ~PUMP_LOCK;
						set_led(LED_LOCK, OFF);
					}
					else{
						potstate |= PUMP_LOCK;
						set_led(LED_LOCK, ON);
					}
					set_flg(TIM_FLGID, TIM_1SEC_BUZZER);
				}
									/* {^ */
				if((event & BUTTON_PUMP) && !(sw & BUTTON_PUMP)){
					if((potstate & (PUMP_ACT|PUMP_LOCK|COVER_OPEN)) == 0){
						set_control(CTL_PUMP, ON);
						potstate |= PUMP_ACT;
						set_flg(TIM_FLGID, TIM_1SEC_BUZZER);
					}
				}
									/* {^ */
				if(!(event & BUTTON_PUMP) && (sw & BUTTON_PUMP)){
					set_control(CTL_PUMP, OFF);
					potstate &= ~PUMP_ACT;
				}
									/* {^ */
				if(!(event & BUTTON_BOIL) && (sw & BUTTON_BOIL)){
					syslog(LOG_INFO, "HEAT_BOILCHG !");
					set_flg(TIM_FLGID, TIM_1SEC_BUZZER);
					set_flg(HEAT_FLGID, HEAT_BOILCHG);
				}
			}
			if(flgptn & EVT_COVER){
									/* Jo[I[v */
				if(!(event & COVER_STATE) && (sw & COVER_STATE)){
					potstate |= COVER_OPEN;
					syslog(LOG_INFO, "cover open HEAT_CHECK !");
					set_flg(HEAT_FLGID, HEAT_CHECK);
				}
									/* Jo[N[Y */
				if((event & COVER_STATE) && !(sw & COVER_STATE)){
					potstate &= ~COVER_OPEN;
					syslog(LOG_INFO, "cover close HEAT_CHECK !");
					set_flg(HEAT_FLGID, HEAT_BOIL);
				}
			}
			sw = event;
		}
	}
}

