/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Ryosuke Takeuchi
 *               Platform Development Center RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: akih8lcd_device.c,v 1.2 2006/05/07 20:41:20 roi Exp $
 */

#include <t_services.h>
#include <t_config.h>
#include <string.h>
#include <sil.h>
#include "sim_device.h"
#include "kernel_id.h"

/*
 * LCD̐M
 */
#define	E_SIG			0x20			/* Cl[uM */
#define	RS				0x10			/* qrM */

extern UB akih8_cled;

/*
 * LCD M
 */
static void
lcd_bit(INT s, INT state)
{
	if(state)
		akih8_cled |= s;
	else
		akih8_cled &= (~s);
	sil_wrb_mem((VP)H8P4DR, akih8_cled);
}

/*
 * LCD 8rbgo
 */
void
lcd_out8(UB c)
{
	lcd_bit(E_SIG, ON);
	akih8_cled = (akih8_cled & 0xc0) | (c & 0x3f);
	sil_wrb_mem((VP)H8P4DR, akih8_cled);
	sil_dly_nse(10000);
	lcd_bit(E_SIG, OFF);
	sil_dly_nse(10000);
}

/*
 * LCD 4rbgo
 */
void
lcd_out4(UB d)
{
	lcd_bit(E_SIG, ON);
	akih8_cled = (akih8_cled & 0xf0) | (d >> 4);
	sil_wrb_mem((VP)H8P4DR, akih8_cled);
	sil_dly_nse(10000);
	lcd_bit(E_SIG, OFF);
	sil_dly_nse(10000);

	lcd_bit(E_SIG, ON);
	akih8_cled = (akih8_cled & 0xf0) | (d & 0x0f);
	sil_wrb_mem((VP)H8P4DR, akih8_cled);
	sil_dly_nse(10000);
	lcd_bit(E_SIG, OFF);
	sil_dly_nse(10000);
}

/*
 * LCD RS
 */
void
lcd_rs_bit(INT state)
{
	lcd_bit(RS, state);
}

/*
 * LCD̏
 */
void
lcd_init(void)
{
	sil_wrb_mem((VP)H8P4DDR, 0xff);			/* |[g4o͐ݒ		*/
					/* LCD̃Zbg */
	lcd_bit(RS, OFF);						/* LCDt@NVZbg1 */
	lcd_out8(0x23);
	sil_dly_nse(1000000);

	lcd_bit(RS, OFF);						/* LCDt@NVZbg2 */
	lcd_out8(0x23);
	sil_dly_nse(1000000);

	lcd_bit(RS, OFF);						/* LCDt@NVZbg3 */
	lcd_out8(0x23);
	sil_dly_nse(1000000);

	lcd_bit(RS, OFF);						/* t@NVZbg */
	lcd_out8(0x22);
	sil_dly_nse(1000000);
					/* LCD̏ */
	lcd_bit(RS, OFF);						/* t@NVZbg */
	lcd_out4(0x28);
	sil_dly_nse(1000000);

	lcd_bit(RS, OFF);						/* \nm */
	lcd_out4(0x0e);
	sil_dly_nse(1000000);

	lcd_bit(RS, OFF);						/* Gg[[h */
	lcd_out4(0x0c);
	sil_dly_nse(1000000);
}

