/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Platform Development Center
 *                              RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: akih8pot_device.h,v 1.2 2006/05/27 20:59:24 roi Exp $
 */

#ifndef _AKIH8POT_DEVICE_H_
#define	_AKIH8POT_DEVICE_H_

#ifdef __cplusplus
extern "C" {
#endif

/*  AKIH8 g|[g` */
/*
 *  A/Dϊ|[g
 */
#define	H8ADDRAH		0xffffe0		/* ADDRAH */
#define	H8ADDRAL		0xffffe1		/* ADDRAL */
#define	H8ADCSR			0xffffe8		/* ADCSR  */

/*
 *  ADCSRWX^rbg`
 */
#define	CSR_ADF			0x80			/* A/DGhtO */
#define	CSR_ADIE		0x40			/* A/DC^vgCl[u */
#define	CSR_ADST		0x20			/* A/DX^[g */
#define	CSR_SCAN		0x10			/* XL[h */
#define	CSR_CKS			0x08			/* NbNI */
#define	CSR_CHN			0x07			/* `l2-0 */

/*
 *  |[gQݒ(IN)
 */
#define	P2_SLEVEL		0xf8			/* SENSE LEVELrbg` */

/*
 *  |[gSݒ(OUT)
 */
#define	P4_LEDBOIL		0x40			/* BOILrbg` */
#define	P4_KEEPWARM		0x80			/* KEEPWARMrbg` */

/*
 *  |[gTݒ(IN)
 */
#define	P5_DIP1			0x01			/* DIP-SW1` */
#define	P5_DIP2			0x02			/* DIP-SW2` */
#define	P5_DIP3			0x04			/* DIP-SW3` */
#define	P5_DIP4			0x08			/* DIP-SW4` */

/*
 *  |[gVݒ(OUT)
 */
#define	P7_LEDLEVEL		0x0f			/* LEVELrbg` */
#define	P7_LEDHIGH		0x10			/* HIGHrbg` */
#define	P7_LEDECO		0x20			/* ECOrbg` */
#define	P7_LEDMILK		0x40			/* MILKrbg` */
#define	P7_LEDLOCK		0x80			/* LOCKrbg` */

/*
 *  |[g`ݒ(OUT)
 */
#define	PA_CNTPUMP		0x01			/* PUMPrbg` */
#define	PA_CNTLOCK		0x02			/* LOCKrbg` */
#define	PA_CNTHEATER	0x04			/* HEATERrbg` */
#define	PA_CNTHEATPWR	0x08			/* HEATPOWERrbg` */
#define	PA_CNTBUZZER	0x10			/* BUZZERrbg` */

/*
 *  |[gaݒ(IN)
 */
#define	PB_SWBOIL		0x01			/* SW BOILrbg` */
#define	PB_SWPUMP		0x02			/* SW PUMPrbg` */
#define	PB_SWUNLOCK		0x04			/* SW UNLOCKrbg` */
#define	PB_SWTIMER		0x08			/* SW TIMERrbg` */
#define	PB_SWMODE		0x40			/* SW MODErbg` */
#define	PB_COVER		0x80			/* COVERrbg` */

/*
 *  |bgVXe`
 */
#define	BUTTON_BOIL		PB_SWBOIL
#define	BUTTON_PUMP		PB_SWPUMP
#define	BUTTON_UNLOCK	PB_SWUNLOCK
#define	BUTTON_TIMER	PB_SWTIMER
#define	BUTTON_MODE		PB_SWMODE

#define	COVER_STATE		PB_COVER

#ifndef _MACRO_ONLY

typedef enum potledid{
	LED_BOIL=0,						/* BOIL ID */
	LED_KEEPWARM,					/* KEEPWARM ID */
	LED_HIGH,						/* HIGH ID */
	LED_ECO,						/* ECO ID */
	LED_MILK,						/* MILK ID */
	LED_LOCK,						/* LOCK ID */
	LED_LEVEL,						/* LEVEL ID */
	NUM_LED							/* Number of LED ID */
} PotLedID;

typedef enum potctlid{
	CTL_PUMP,						/* PUMP ID */
	CTL_LOCK,						/* LOCK ID */
	CTL_HEATER,						/* HEATER ID */
	CTL_HEATPOWER,					/* HEATPOWER ID */
	CTL_BUZZER,						/* BUZZER ID */
	NUM_CTL							/* Number of CTL ID */
} PotCtlID;

/*
 *  LED̃IItݒ
 */
#define	ON			1			/* I */
#define	OFF			0			/* It */

/*
 *  LCDfBCJEg
 */
#define	DCNT_FNC		1000000

/*
 *  foCX̃vg^Cv錾
 */
extern void initial_pot(void);
extern int  get_switch(void);
extern int  get_key(int sw);
extern int  get_temp(void);
extern int  get_level(void);
extern void set_led(PotLedID led, int req);
extern void set_control(PotCtlID id, int req);
extern void display_temp(H temp, UH level);
extern void display_time(UW time);
extern unsigned long get_simtime(void);

#endif /* _MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif /* _AKIH8POT_DEVICE_H_ */

