/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Platform Development Center
 *                              RICOH COMPANY,LTD. JAPAN
 *
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: pottn.h,v 1.2 2006/05/07 20:56:24 roi Exp $
 */

/* 
 *  j^[eXgpTvvÕwb_t@C
 */
#include <t_services.h>
#include <t_config.h>

#define TEX_LOOP	500000			/* O[`ł̃[v */


/*
 *  ^XNDx̐ݒ
 */
#define EVENT_PRIORITY      4
#define	BUTTON_PRIORITY     8
#define	ERROR_PRIORITY      10
#define	HEATER_PRIORITY     11
#define TIMER_PRIORITY      12

/*
 *  ^[QbgɈˑ\̂萔̒`
 *  X^bNTCY
 */

#ifdef STACK_SIZE
#undef STACK_SIZE
#endif /* STACK_SIZE */
#define	STACK_SIZE	1024			/* ^XÑX^bNTCY */

/*
 *  ^C}[vZX̎Ԑݒ
 */
#define	S_TICK				2		/* V~[VTICK(200ms) */
#define	S_1SEC				10		/* V~[V^C}[̂Pb */

/*
 *  q[^֌W^XN̎sԊu
 */
#define	HEATER_CYCLE		100		/* 100ms */
#define	TEST_CYCLE			100		/* 100ms */

/*
 *  EVT_FLGID̃rbg`
 */
#define	EVT_BUTTON			0x01	/* {^ */
#define	EVT_COVER			0x02	/* Jo[I[v */

#define	EVT_EVENT	(EVT_BUTTON|EVT_COVER)

/*
 *  TIM_FLGID̃rbg`
 */
#define	TIM_SWITCH			0x01	/* ^C}[N */
#define	TIM_1SEC_BUZZER		0x02	/* 1buU[ */
#define	TIM_30SEC_BUZZER	0x04	/* 30buU[ */

#define	EVT_TIME	(TIM_SWITCH|TIM_1SEC_BUZZER|TIM_30SEC_BUZZER)

/*
 *  HEAT_FLGID̃rbg`
 */
#define	HEAT_CHECK			0x01	/* ԕύX */
#define	HEAT_BOIL			0x02	/* w */
#define	HEAT_BOILCHG		0x04	/* {^ */
#define	HEAT_ERROR			0x10	/* G[ */

#define	EVT_HEAT	(HEAT_CHECK|HEAT_BOIL|HEAT_BOILCHG|HEAT_ERROR)

/*
 *  POTSTATE̓e`
 */
#define	HIGH_MODE			0x01	/* ۉ[hF */
#define	ECO_MODE			0x02	/* ۉ[hFߖ */
#define	MILK_MODE			0x03	/* ۉ[hF~N */
#define	PUMP_LOCK			0x10	/* PUMPbN */
#define	PUMP_ACT			0x20	/* PUMP쒆 */
#define	COVER_OPEN			0x40	/* COVERJ */
#define	MODE_MASK			0x03

/*
 * Onh̐ݒ
 */
#define	INT_IRG		64				/* CM[݃nhԍ */
#define EXC_IRG		64				/* CM[Onhԍ */
#define irregular_ext_handler_intmask  	IPM_LEVEL2

/*
 *  ֐̃vg^Cv錾
 */
#ifndef _MACRO_ONLY

extern void button_task(VP_INT exinf);
extern void	event_task(VP_INT exinf);
extern void timer_task(VP_INT exinf);
extern void heater_task(VP_INT exinf);
extern void error_task(VP_INT exinf);

/*
 *  Lϐ̒`
 */
extern unsigned char potstate;
extern unsigned char potlevel;
extern unsigned short pottemp;

#endif /* _MACRO_ONLY */
