/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Ryosuke Takeuchi
 *               Platform Development Center RICOH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: akih8_device.c,v 1.1 2004/06/20 11:40:20 roi Exp $
 */

#include <t_services.h>
#include <t_config.h>
#include <string.h>
#include <monsil.h>
#include "sim_device.h"
#include "kernel_id.h"

/*  3069FpvO */
/*
 *  |[gQݒ
 */
#define	P2_SW1			0x10			/* SW1rbg` */
#define	P2_SW2			0x20			/* SW2rbg` */
#define	P2_SW3			0x40			/* SW3rbg` */
#define	P2_SW4			0x80			/* SW4rbg` */

/*
 *  |[gSݒ
 */
#define	P4_LED1			0x40			/* LED1rbg` */
#define	P4_LED2			0x80			/* LED2rbg` */

/*
 *  |[gTݒ
 */
#define	P5_DIP1			0x01			/* DIP-SW1` */
#define	P5_DIP2			0x02			/* DIP-SW2` */
#define	P5_DIP3			0x04			/* DIP-SW3` */
#define	P5_DIP4			0x08			/* DIP-SW4` */

#if 0
#define TINTLVL0        5
#define TIMER_CLOCK		625
#endif

/*
 * LCD̊֐
 */
extern void lcd_init(void);
extern void lcd_out8(UB c);
extern void lcd_out4(UB d);
extern void lcd_rs_bit(INT state);

static char const raddec[] = "0123456789";
static char const init_lcd[] = " H8-Timer [OFF] ";
static UB lcdbuf[32];
static UB ckey;
static UB tsw4;
static UB tsw5;
static UB lsw4;

UB akih8_cled;

/*
 *  j^[̋N̗LԂ
 */
BOOL
need_monitor()
{
	if(!(sil_reb_mem((VP)H8P5DR) & P5_DIP1))
		return TRUE;
	else{
		act_tsk(ENTRY_TASK);
		return FALSE;
	}
}

/*
 *  ^C}[̏ݒ
 *  1msɊ݂𔭐
 *  (TOPPERSł͎gpȂ)
 */
void
initial_timer()
{
#if 0
	sil_wrb_mem((VP)TADR_SFR_UDF, 0x00);	/* _EJEgݒ	*/
	sil_wrb_mem((VP)TADR_SFR_TA0MR, 0x80);	/* ^C}[h	NbNF1/32	*/
											/* ^C}l̏				*/
	sil_wrh_mem((VP)TADR_SFR_TA0, TIMER_CLOCK-1);
											/* 荞݃x̐ݒ			*/
	sil_wrb_mem((VP)(TADR_SFR_INT_BASE+TADR_SFR_TA0IC_OFFSET), TINTLVL0);
	sil_wrb_mem((VP)TADR_SFR_TABSR, 0x01);	/* JEgJn					*/
#endif
}

/*
 *  XCb`̏֐
 */
void
initial_key()
{
	sil_wrb_mem((VP)H8P2DDR, 0x0f);			/* |[g2:4-7͐ݒ		*/
	sil_wrb_mem((VP)H8P2PCR, 0xff);			/* |[g2vAbv	*/
	ckey = sil_reb_mem((VP)H8P2DR);			/* l̎荞 */
	tsw4 = tsw5 = OFF;
}

/*
 *  LED̏֐
 */
void
initial_led()
{
					/* LED̏ */
	sil_wrb_mem((VP)H8P4DDR, 0xff);			/* |[g4o͐ݒ		*/
	akih8_cled  = sil_reb_mem((VP)H8P4DR);
	akih8_cled &= ~(P4_LED1|P4_LED2);
	sil_wrb_mem((VP)H8P4DR, akih8_cled);	/* |[g4f[^	*/
					/* LCD̃Zbg */
	lcd_init();
	strcpy(lcdbuf, init_lcd);
}

/*
 *  XCb`̏Ԃo
 *  arg1:SW1܂SW2
 */
int
get_key(int sw)
{
	UB   key;
	int  result = OFF;
	key = sil_reb_mem((VP)H8P2DR);			/* ݒl̎荞 */
	if(key != ckey){
		if(!(key & P2_SW2))
			tsw5 = OFF;
		if(!(key & P2_SW1))
			tsw5 = ON;
		if(!(key & P2_SW4))
			tsw4 = OFF;
		if(!(key & P2_SW3)){
			tsw4 = ON;
			lsw4 = 6;
		}
		ckey = key;
	}
	else if(lsw4 > 0){
		if(--lsw4 == 0)
			tsw4 = OFF;
	}
	switch(sw){
	case SW4:
		result = tsw4;
		break;
	case SW5:
		result = tsw5;
		break;
	default:
		break;
	}
	return result;
}

/*
 *  LED̐ݒs
 *  arg1:LED1܂LED2
 *  arg2:ON܂OFF
 */
void
set_led(int led, int req)
{
	volatile UB rled = akih8_cled;

	switch(led){
	case LED2:
		rled &= ~P4_LED1;
		if(req == ON)
			rled |= P4_LED1;
		break;
	case LED3:
		rled &= ~P4_LED2;
		if(req == ON)
			rled |= P4_LED2;
		break;
	default:
		break;
	}
	if(akih8_cled != rled){
		akih8_cled = rled;
		sil_wrb_mem((VP)H8P4DR, akih8_cled);
	}
}

/*
 * ^C}[̏Ԃ\
 * arg1:^C}[ő厞
 * arg2:ݎ
 */
void
display_time(UW maxtime, UW currenttime)
{
	int i, j;

	if(maxtime){							/* ON/OFF̐ݒ */
		lcdbuf[11] = 'O';
		lcdbuf[12] = 'N';
		lcdbuf[13] = ']';
		lcdbuf[14] = ' ';
	}
	else{
		lcdbuf[11] = 'O';
		lcdbuf[12] = 'F';
		lcdbuf[13] = 'F';
		lcdbuf[14] = ']';
	}
	memset(&lcdbuf[16], ' ', 16);			/* Ԃ̐ݒ */
	if(maxtime){
		j = maxtime / 1000;
		i = 16+5;
		do {
			lcdbuf[i--] = raddec[j % 10];
			j /= 10;
		} while (j != 0);
	}
	j = currenttime / 1000;
	i = 16+13;
	do {
		lcdbuf[i--] = raddec[j % 10];
		j /= 10;
	} while (j != 0);

	lcd_rs_bit(OFF);						/* J[\[z[ */
	lcd_out4(0x02);
	sil_dly_nse(1000000);

	for(i = 0 ; i < 16 ; i++){
		lcd_rs_bit(ON);						/* 1sڕ\ */
		lcd_out4(lcdbuf[i]);
		lcd_rs_bit(OFF);
	}

	lcd_rs_bit(OFF);						/* z[2s */
	lcd_out4(0xc0);
	sil_dly_nse(1000000);
	for(i = 0 ; i < 16 ; i++){
		lcd_rs_bit(ON);						/* 2sڕ\ */
		lcd_out4(lcdbuf[i+16]);
		lcd_rs_bit(OFF);
	}
}

