/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                              RICOH COMPANY,LTD. JAPAN
 *
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: timer3.c,v 1.2 2004/03/23 17:05:20 roi Exp $
 */

/* 
 *  TOPPERSp̃TvvO
 *  entry_taskł̓XCb`SCT̃ZVOA
 *  timer_taskł͎ԂLED̊ǗsAȒPȃ^C}[D
 *  ʏLED3Pbɓ_łD
 *  XCb`TIŃ^C}[NA10bƂLED2̓_ŁAPLED2
 *  A[g_łB̂ƂXCb`SI邲ƂɃA[g_ŎԂ
 *  PZAA[g_ŎԂD
 *  RɃA[g_łɂ́AXCb`TIǍAXCb`S
 *  QIɂD
 *  ܂AhCo[PDICɏ邽߁Asfrt@C͎gpȂD
 *
 */

#include <t_services.h>
#include "kernel_id.h"
#include "sim_device.h"
#include "timer3.h"

/*
 *  ^C}vZX̏
 */
enum TIMER_STATE {
	STATE_STOP_TIMER,			/* ^C}[~ */
	STATE_ACT_TIMER				/* ^C}[s */
};

/*
 *  ^C}p^XN
 */
void
timer_task(VP_INT exinf)
{
	SYSTIM  base_time, current_time;
	SYSTIM  start_time, last_time;
	SYSTIM  alaem_time = 0;
	TMO     tmout = 0;
	INT     timer_state = STATE_STOP_TIMER;
	ER      ercd;
	FLGPTN  flgptn;
	UB      led2 = OFF;
	UB      led3 = OFF;
	UB      sled3;

	syslog(LOG_INFO, "Sample1 timer task starts (exinf = %d).", exinf);
	initial_led();			/* LED̏ */
	get_tim(&base_time);	/* ݎԂ̎o */
	for(;;){
		ercd = twai_flg(EVT_FLGID, EVT_TIME, TWF_ORW, &flgptn, tmout);
		if(ercd == E_OK){	/* entry_taskʒm */
			clr_flg(EVT_FLGID, ~flgptn);
			if(flgptn & EVT_TIMER_START){
				timer_state = STATE_ACT_TIMER;
				start_time = base_time;
				last_time = start_time + 60*T_1SEC;
				syslog(LOG_INFO, "Timer Start !");
			}
			if(flgptn & EVT_TIMER_COUNT){
				if(timer_state != STATE_STOP_TIMER){
					last_time += 60*T_1SEC;
				}
				syslog(LOG_INFO, "Timer Count Up !");
			}
			if(flgptn & EVT_TIMER_STOP){
				timer_state = STATE_STOP_TIMER;
				alaem_time = 0;
				syslog(LOG_INFO, "Timer Stop !");
			}
		}
		switch(timer_state){	/* ^C}[Ԃ̔ */
		case STATE_ACT_TIMER:	/* ^C}[s */
			if(last_time <= current_time){
				alaem_time = base_time + 30*T_1SEC;
				timer_state = STATE_STOP_TIMER;
			}
			else if(((base_time - start_time) % (10*T_1SEC)) == 0){
				alaem_time = base_time + T_1SEC;
			}
			break;
		default:				/* ^C}[~ */
			break;
		}
								/* bLED3I */
		sled3 = (UB)((base_time / T_1SEC) & ON);
		if(led3 != sled3){
			led3 = sled3;
			if(timer_state == STATE_STOP_TIMER){
				syslog_1(LOG_INFO, "system time=%d", base_time);
				display_time(0, base_time);
			}
			else{
				syslog_2(LOG_INFO, "max time=%d current time=%d", last_time-start_time, base_time-start_time);
				display_time(last_time-start_time, base_time-start_time);
			}
		}
								/* x̗v:TICKLED2I */
		if(alaem_time > base_time){
			led2 = (UB)(((alaem_time - base_time) / T_TICK) & ON);
			led2 ^= ON;			/* LED2 ̃I A It؂ւ */
		}
		else{					/* x̗vȂLED2IȂ */
			led2 = OFF;
		}

		set_led(LED2, led2);	/* LED2̐ݒ */
		set_led(LED3, led3);	/* LED3̐ݒ */
		get_tim(&current_time);
		if(current_time >= base_time){
			base_time += T_TICK;
		}
		tmout = base_time - current_time;
		if(tmout < 0){
			tmout = 0;
		}
	}
}

/*
 *  C^XN
 *  (XCb`vZX)
 */
void
entry_task(VP_INT exinf)
{
	UB    sw4, sw5, sw;

#ifdef S_DEBUG
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
#endif
	syslog(LOG_INFO, "Sample entry task starts (exinf = %d).", exinf);
	initial_key();			/* L[̏ */
	sw4 = get_key(SW4);		/* ݂SW4̎荞 */
	sw5 = get_key(SW5);		/* ݂SW5̎荞 */
	clr_flg(EVT_FLGID, 0);
	act_tsk(TIMER_TASK);	/* ^C}[^XN̋N */

	for(;;){
		tslp_tsk(100);
		sw = get_key(SW5);
		if(sw5 != sw){
			syslog(LOG_INFO, "Change switch5 = 0x%x.", sw);
			if(sw == ON){
				set_flg(EVT_FLGID, EVT_TIMER_START);
			}
			else{
				set_flg(EVT_FLGID, EVT_TIMER_STOP);
			}
			sw5 = sw;
		}
		sw = get_key(SW4);
		if(sw4 != sw){
			syslog(LOG_INFO, "Change switch4 = 0x%x.", sw);
			if(sw == ON){
				set_flg(EVT_FLGID, EVT_TIMER_COUNT);
			}
			sw4 = sw;
		}
	}
}

