/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2003-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: monitor.h,v 1.4 2005/12/07 14:32:20 roi Exp $
 */

#ifndef _MONITOR_H_
#define	_MONITOR_H_

#ifdef __cplusplus
extern "C" {
#endif

/* 
 *  ˥ץץΥإåե
 */
#include <t_services.h>

/*
 *  ͥ٤
 */
#define MONITOR_PRIORITY	3

/*
 *  ˥Υ
 */
#if defined(M16C)
#define	MONITOR_STACK_SIZE	512		/* Υå */
#elif defined(H8) && !defined(SUPPORT_ETHER)
#define	MONITOR_STACK_SIZE	768		/* Υå */
#else
#define	MONITOR_STACK_SIZE	2046	/* Υå */
#endif
#define	MAX_COMMAND_LENGTH	80		/* ˥κ祳ޥĹ */
#define	NUM_LOG_DISP		3		/* ɽƥ */

/*
 *  С
 */
#define	TMONITOR_PRVER	0x1010		/* ͥΥСֹ */

/*
 *  Ƥ
 */
#define	KEY_BS			(8)			/* Хåڡ */
#define	KEY_DEL			(127)		/*  */
#define KEY_NL			(10)		/* 1 */
#define	KEY_CR			(13)		/* 2 */
#define	KEY_EXT			(1)			/* λ */

/*
 *  ǡ
 */
#define	DATA_BYTE		1			/* ХȥǡʣХȡ*/
#define	DATA_HALF		2			/* ϡեǡʣХȡ*/
#define	DATA_WORD		4			/* ɥǡʣХȡ*/

/*
 *  ΰ°
 */
#define	NONE_AREA		0			/* ΰγƤΤʤΰ */
#define	PORT_AREA		1			/* ϡɥΥݡΰ */
#define	MEMORY_AREA		2			/* ΰ衡*/

#define	MREAD_ONLY		1			/* ɤ߹ */
#define	MWRITE_ONLY		2			/* 񤭹 */
#define	MREAD_WRITE		(MREAD_ONLY+MWRITE_ONLY)

#ifndef _MACRO_ONLY

/*
 *  ޥɥǥѥåѤι¤
 */
struct COMMAND_TABLE {
	const char *command;			/* ޥʸ */
	UW  (*func)(B * command);		/* ¹Դؿ */
};

struct SUBCOMMAND_TABLE {
	const char *subcommand;			/* ֥ޥʸ */
	B const type;					/* ¹ԥ */
};

/*
 *  ؿΥץȥ
 */

extern BOOL need_monitor(void);
extern void	monitor(VP_INT exinf);
extern void monitor_sub(VP_INT exinf);
extern UB   getMemoryType(UW address, INT mode);
extern INT  MemoryRead(UW address, VP_INT p, INT type);
extern INT  MemoryWrite(UW address, VP_INT p, INT type);
extern UW   MonAlignAddress(UW address);
extern INT  MemoryRead(UW address, VP_INT p, INT type);
extern INT  MemoryWrite(UW address, VP_INT p, INT type);
extern UW   get_exception_pc(VP p_excinf);
extern void display_registers(ID tskid);
extern UW   display_assembler(UW pc);

/*
 *  ڡ򥹥åפ
 */
Inline void
skip_space(B *command, INT *point)
{
	while(command[*point] == ' ' || command[*point] == '\t')
		(*point)++;
}

/*
 *  ʸ򥹥åפ
 */
Inline void
skip_word(B *command, INT *point)
{
	while(command[*point] != ' ' && command[*point] != '\t'
             && command[*point] != ',' && command[*point] != 0)
		(*point)++;
	if(command[*point] != 0)
		(*point)++;
	skip_space(command, point);
}

/*
 *  ʸ󤫤Ф
 *  ͤFALSEʤ̤ͤǤ뤳Ȥ򼨤
 */
Inline BOOL
get_value(B *s, INT *point, UW *v, INT card)
{
	B    c;

	*v = 0;
	if(s[*point] == 0)
		return FALSE;
	else if(s[*point] == ' ' || s[*point] == '\t'
               || s[*point] == ',' || s[*point] == '.'){
		(*point)++;
		skip_space(s, point);
		return FALSE;
	}
	else{
		while(s[*point]){
			c = s[*point];
			(*point)++;
			if(c >= '0' && c <= '9')
				c -= '0';
			else if(c >= 'A' && c <= 'Z')
				c -= 'A' - 10;
			else if(c >= 'a' && c <= 'z')
				c -= 'a' - 10;
			else
				break;
			*v = *v * card + c;
		}
		skip_space(s, point);
		return TRUE;
	}
}

#endif /* _MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif /* _MONITOR_H_ */

