/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: netdevice.c,v 1.3 2006/05/07 23:37:19 roi Exp $
 */

/* 
 *  ͥåȥǥХ󥿡եץ
 */
#include "jsp_kernel.h"
#include "wait.h"
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdio.h>
#include <stdlib.h>

#include <net/net.h>
#include "netdevice.h"

NETQUEUE  in_buf;
NETQUEUE  out_buf;
DATAQUEUE data_buf;
unsigned  long netdevice_count = 0;

static DATAQUEUE key_buf;
static NETBLOCK  inblk[BUF_SIZE];
static SNETBLOCK oublk[BUF_SIZE];
static TMEVTB    intreq[MAX_INT];

static void call_netint(void (func)());

extern void monitor_sub(VP_INT exinf);

/*
 *  ѿ
 */
extern BOOL net_activate;

#ifdef DEVSERV
/*
 *  ˥Σʸʸ
 */
static int
netdevice_getc(void)
{
  int head, c;

  for(;;){
   head = key_buf.head;
   if(head != key_buf.tail){
     c = key_buf.buf[head++];
     if(head >= NETDATALEN)
       head = 0;
     key_buf.head = head;
     return c;
   }
   wai_sem(SEMID_NETKEY);
  }
}

/*
 *  ˥Σʸʸ
 */
static void
netdevice_putc(int c)
{
  int tail;

  while(net_activate){
    tail = data_buf.tail;
    data_buf.buf[tail++] = c;
    if(tail >= NETDATALEN)
      tail = 0;
    if(data_buf.head != tail){
      data_buf.tail = tail;
      break;
    }
    sig_sem(SEMID_TCP_SEND_WAIT);
    dly_tsk(50);
  }
  if(c == 0x0a)		/* newline */
    sig_sem(SEMID_TCP_SEND_WAIT);
}

/*
 *  ˥ʸʸ
 */
static int
netdevice_puts(int len, char *s)
{
  int tail;

  while(net_activate && len > 0){
    tail = data_buf.tail;
    data_buf.buf[tail++] = *s;
    if(tail >= NETDATALEN)
      tail = 0;
    if(data_buf.head != tail){
      data_buf.tail = tail;
      s++;
      len--;
    }
    else{
      sig_sem(SEMID_TCP_SEND_WAIT);
      dly_tsk(50);
    }
  }
  sig_sem(SEMID_TCP_SEND_WAIT);
  return 0;
}

/*
 *  ˥Υǡեå饷ʸ
 */
static int
netdevice_flush()
{
  sig_sem(SEMID_TCP_SEND_WAIT);
  return 0;
}

/*
 *  ˥Ĺ
 */
int
netdevice_keylen()
{
  int len;

  len = key_buf.tail - key_buf.head;
  if(len < 0)
    len += NETDATALEN;
  return len;
}
#endif

/*
 *  ͥåȥǥХν
 */
void
_init_netdevice()
{
  FILE *st;
  int  i;

  in_buf.head  =
  in_buf.tail  = 0;
  in_buf.size  = BUF_SIZE;
  for(i = 0 ; i < BUF_SIZE ; i++)
    in_buf.buffer[i] = &inblk[i];

  out_buf.head =
  out_buf.tail = 0;
  out_buf.size = BUF_SIZE;
  for(i = 0 ; i < BUF_SIZE ; i++)
    out_buf.buffer[i] = (NETBLOCK *)&oublk[i];

  for(i = 0 ; i < MAX_INT ; i++){
    intreq[i].callback = (CBACK)call_netint;
    intreq[i].arg      = 0;
  }

  key_buf.head =
  key_buf.tail = 0;

#ifdef DEVSERV
  for(i = 0 ; i < 3 ; i++){
    st = _get_stdio(i);
    st->_func_in    = netdevice_getc;
    st->_func_out   = netdevice_putc;
    st->_func_outs  = netdevice_puts;
    st->_func_flush = netdevice_flush;
  }
#endif
}

#ifdef NETDEVICE_WAIT
/*
 *  Ԥؿ(Ԥɬפʤ)
 */
static void
netdevice_wait()
{
  int tail;

  tail = out_buf.tail+1;
  if(tail >= out_buf.size)
    tail = 0;
  while(out_buf.head == tail){
    sig_sem(SEMID_TCP_SEND_WAIT);
    dly_tsk(20);
  }
}
#endif

/*
 *  ͥåȥǥХΥƥ־֤䤤碌
 */
BOOL
NetDeviceActive()
{
  return net_activate != 0;
}

/*
 *  ͥåȥǥХФݡɤ߽Ф
 */
BOOL
NetDeviceRead(unsigned long address, unsigned long size, void * storage)
{
  NETBLOCK *p;

  if(sense_context()){				/* ƥȥƥ */
    syslog_1(LOG_ERROR, "read netDevice(0x%x) in non-task context!", address);
    return TRUE;					/* netDeviceˤϹԤʤ */
  }
  wai_sem(SEMID_NETDEVICE);			/* netDevice¾ */
  if(net_activate){
    wai_sem(SEMID_NETQUEUE);		/* ¾ */
#ifdef NETDEVICE_WAIT
    netdevice_wait();
#endif
    p = out_buf.buffer[out_buf.tail++];
    p->command = NETDEVTYPE_CLIENT|NETDEVTYPE_REQRPY|NETDEVICE_READ;
    p->size    = sizeof(NETBLOCK);
    p->sub     = size;
    p->cnt     = htonl(++netdevice_count);
    p->arg1    = htonl(address);
    if(out_buf.tail >= out_buf.size)
      out_buf.tail = 0;
    sig_sem(SEMID_NETQUEUE);		/* ¾λ */
    sig_sem(SEMID_TCP_SEND_WAIT);	/* ׵ */
    wai_sem(SEMID_NETWAIT);			/* replyԤ */
    p = in_buf.buffer[in_buf.head];	/* replyǡ */
    switch(size){
    case 2:
      *((unsigned short *)storage) = p->arg2.h[0];
      break;
    case 4:
      *((unsigned long *)storage) = p->arg2.w;
      break;
    default:
      *((unsigned char *)storage) = p->arg2.b[0];
      break;
    }
    in_buf.head++;
    if(in_buf.head >= in_buf.size)
      in_buf.head = 0;
    sig_sem(SEMID_NETDEVICE);		/* netDevice¾λ */
    return TRUE;					/* ǡߴλ */
  }
  else{
    sig_sem(SEMID_NETDEVICE);		/* netDevice¾λ */
    return FALSE;					/* ǡߤǤ */
  }
}

/*
 *  ͥåȥǥХФݡȽ񤭹
 */
BOOL
NetDeviceWrite(unsigned long address, unsigned long size, void * storage)
{
  NETBLOCK *p;

  if(sense_context()){				/* ƥȥƥ */
    syslog_1(LOG_ERROR, "write netDevice(0x%x) in non-task context!", address);
    return TRUE;					/* netDeviceˤϹԤʤ */
  }
  wai_sem(SEMID_NETDEVICE);			/* netDevice¾ */
  if(net_activate){
    wai_sem(SEMID_NETQUEUE);		/* ¾ */
#ifdef NETDEVICE_WAIT
    netdevice_wait();
#endif
    p = out_buf.buffer[out_buf.tail++];
    p->command = NETDEVTYPE_CLIENT|NETDEVTYPE_REQRPY|NETDEVICE_WRITE;
    p->size    = sizeof(NETBLOCK);
    p->sub     = size;
    p->cnt     = htonl(++netdevice_count);
    p->arg1    = htonl(address);
    switch(size){
    case 1:
      p->arg2.b[0] = *((unsigned char *)storage);
      break;
    case 2:
      p->arg2.h[0] = *((unsigned short *)storage);
      break;
    default:
      p->arg2.w = htonl(*((unsigned long *)storage));
      break;
    }
    if(out_buf.tail >= out_buf.size)
      out_buf.tail = 0;
    sig_sem(SEMID_NETQUEUE);		/* ¾λ */

    sig_sem(SEMID_TCP_SEND_WAIT);	/* ׵ */
    wai_sem(SEMID_NETWAIT);			/* replyԤ */
    in_buf.head++;					/* replyɤ߼Τ */
    if(in_buf.head >= in_buf.size)
      in_buf.head = 0;
    sig_sem(SEMID_NETDEVICE);		/* netDevice¾λ */
    return TRUE;					/* ǡѤ */
  }
  else{
    sig_sem(SEMID_NETDEVICE);		/* netDevice¾λ */
    return FALSE;					/* ǡǤ */
  }
}

/*
 *  
 */
BOOL
NetDeviceSetInt(UW no, void (*func)(VP arg))
{
  if(no < MAX_INT){
    intreq[no].arg = (VP)func;
    return TRUE;
  }
  else
    return FALSE;
}

/*
 *  NETBLOCKμ
 */
BOOL
_net_setup_input_buffer(NETQUEUE *ib)
{
  NETBLOCK *nb;
  int      no;
  BOOL     result = TRUE;

  nb = ib->buffer[ib->tail];
  if(nb->command & NETDEVTYPE_RPY){		/* ̾Υץ饤б */
    ib->tail++;
    if(ib->tail >= ib->size)
      ib->tail = 0;
    sig_sem(SEMID_NETWAIT);
  }
  else{									/* ¾μ */
    if((nb->command & NETDEVTYPE_CMASK) == NETDEVICE_INT){
      no = htonl(nb->arg1);				/* ߤб */
      loc_cpu();
      if(intreq[no].arg){
        tmevtb_insert(&intreq[no], base_time);
      }
      unl_cpu();
    }
    else if((nb->command & NETDEVTYPE_CMASK) == NETDEVICE_DATA){
      char *b;
      int  tail;
      b = (char *)&nb->arg1;
      for(no = 0 ; no < nb->sub ; no++){
        tail = key_buf.tail;
        key_buf.buf[tail++] = *b++;
        if(tail >= NETDATALEN)
          tail = 0;
        if(key_buf.head != tail)
          key_buf.tail = tail;
      }
      sig_sem(SEMID_NETKEY);
    }
    else								/* ͽʤ */
      syslog(LOG_ERROR, "error command=%d!!", (nb->command &NETDEVTYPE_CMASK));
  }
  return result;
}

/*
 * Хåؿ
 */
static void
call_netint(void (func)())
{
  i_unlock_cpu();
  func();
  i_lock_cpu();
}

