/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2003-2005 by Ryosuke Takeuchi
 *               Platform Development Center RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: oaks16.c,v 1.2 2005/12/07 16:41:29 roi Exp $
 */

/* 
 *  TOPPERS/JSPѥ˥CPU¸ץࡥ
 *
 */

#include <t_services.h>
#include <s_services.h> 
#include <sil.h>
#include <stdio.h>
#include <string.h>
#include "jsp_kernel.h"
#include "task.h"
#include "task_expansion.h"
#include "monitor.h"

extern void _kernel_break_wait();

/*
 * 쥸ι¤
 */
typedef struct t_reg{
	UH	r0;
	UH	r1;
	UH	r2;
	UH	r3;
	UH	a0;
	UH	a1;
	UH	sb;
	UH	fb;
	UH	lpc;
	UB	lflg;
	UB	hpc;
}T_REG;

/*
 * Υޥåԥ¤
 */

typedef struct t_memdef{
	UW	mstart;
	UW	mend;
	UB	mtype;
	UB	mstate;
}T_MEMDEF;

/*
 * OAKS16Υޥåԥ
 */

static T_MEMDEF const memdefine[] = {
	0x00000000,	0x000003FF, PORT_AREA,   MREAD_WRITE,
#if defined(OAKS16)
	0x00000400, 0x00002BFF, MEMORY_AREA, MREAD_WRITE,
	0x000E0000, 0x000FFFFF, MEMORY_AREA, MREAD_ONLY
#elif defined(OAKS16_MINI)
	0x00000400, 0x00000BFF, MEMORY_AREA, MREAD_WRITE,
	0x000F0000, 0x000FFFFF, MEMORY_AREA, MREAD_ONLY
#else
#error "No board type in OAKS16 groups."
#endif
};

/******************************************************************************
 * ϡɥݡ°ȴؿ
 ******************************************************************************/
/*
 *  ɥ쥹ΰ°Ф
 *  mode=0:ΰη
 *  mode=1:ɤ߼񤭹°
 */

UB
getMemoryType(UW address, INT mode)
{
	INT count = sizeof(memdefine) / sizeof(T_MEMDEF);
	INT i;

	for(i = 0 ; i < count ; i++){
		if(address >= memdefine[i].mstart && address <= memdefine[i].mend){
			if(mode == 0)
				return memdefine[i].mtype;
			else
				return memdefine[i].mstate;
		}
	}
	return NONE_AREA;
}

/*
 *  ɥ쥹饢饤Υɥ쥹Ф
 */

UW
MonAlignAddress(UW address)
{
	return address;
}

/******************************************************************************
 * ꥢѴؿ
 ******************************************************************************/
/*
 *  ΰФɤ߽Фؿ
 *  ΰΥåԤ顼ʤ饼֤
 */
INT
MemoryRead(UW address, VP_INT p, INT type)
{
	INT  len;

	switch(getMemoryType(address, 0)){
	case PORT_AREA:
		if(type == 2){
			len = 2;
			*((UH _far *)p) = sil_reh_mem((VP)address);
		}
		else if(type == 4){
			len = 4;
			*((UW _far *)p) = sil_rew_mem((VP)address);
		}
		else{
			len = 1;
			*((UB _far *)p) = sil_reb_mem((VP)address);
		}
		break;
	case MEMORY_AREA:
		if(type == 2){
			len = 2;
			*((UH _far *)p) = *((UH _far *)address);
		}
		else if(type == 4){
			len = 4;
			*((UW _far *)p) = *((UW _far *)address);
		}
		else{
			len = 1;
			*((UB _far *)p) = *((UB _far *)address);
		}
		break;
	default:
		len = 0;
		break;
	}
	return len;
}

/*
 *  ΰФ񤭹ߴؿ
 *  ΰΥåԤ顼ʤ饼֤
 */
INT
MemoryWrite(UW address, VP_INT p, INT type)
{
	INT  len;

	switch(getMemoryType(address, 0)){
	case PORT_AREA:
		if(type == 2){
			len = 2;
			sil_wrh_mem((VP)address, *((UH _far *)p));
		}
		else if(type == 4){
			len = 4;
			sil_wrw_mem((VP)address, *((UW _far *)p));
		}
		else{
			len = 1;
			sil_wrb_mem((VP)address, *((UB _far *)p));
		}
		break;
	case MEMORY_AREA:
		if(getMemoryType(address, 1) == MREAD_ONLY){
			len = 0;
		}
		else if(type == 2){
			len = 2;
			*((UH _far *)address) = *((UH _far *)p);
		}
		else if(type == 4){
			len = 4;
			*((UW _far *)address) = *((UW _far *)p);
		}
		else{
			len = 1;
			*((UB _far *)address) = *((UB _far *)p);
		}
		break;
	default:
		len = 0;
		break;
	}
	return len;
}

/******************************************************************************
 * ˥Ѵؿ
 ******************************************************************************/
/*
 *  ץΰpcФؿ
 */
UW
get_exception_pc(VP p_excinf)
{
	UW pc;

	pc = *(UH*)((char*)p_excinf+16) | ((UW)(*((char*)p_excinf+19) & 0xf) << 16);
	return pc;
}

/*
 *  쥸Ƥɽ
 */
void
display_registers(ID tskid)
{
	ER     ercd;
	T_RTST rtst;
	T_REG  reg;
	UW     pc;

	ercd = ref_tst(tskid, &rtst);
	if(ercd == E_OK){
		if(rtst.tskpc == (FP)_kernel_break_wait){
			reg = *((T_REG *)rtst.tsksp);
			pc = reg.lpc | (((UW)reg.hpc & 0xf)<<16);
			printf("  PC=%06lx SP=%04x", (unsigned long)pc, (UW)rtst.tsksp+sizeof(T_REG));
			printf("       IPL=%1x U=%1x I=%1x", (reg.hpc>>4) & 0x7, (reg.lflg>>7) & 1, (reg.lflg>>6) & 1);
			printf(" O=%1x B=%1x S=%1x", (reg.lflg>>5) & 1, (reg.lflg>>4) & 1, (reg.lflg>>3) & 1);
			printf(" Z=%1x D=%1x C=%1x\n", (reg.lflg>>2) & 1, (reg.lflg>>1) & 1, reg.lflg & 1);
			printf("  R0=%04x R1=%04x R2=%04x", reg.r0, reg.r1, reg.r2);
			printf(" R3=%04x A0=%04x A1=%04x", reg.r3, reg.a0, reg.a1);
			printf(" SB=%04x FB=%04x\n", reg.sb, reg.fb);
			printf("     %06lx    %02x %02x\n", (unsigned long)pc, *((UB*)pc), *((UB*)(pc+1)));
			return;
		}
		else if(rtst.tskstat == TTS_DMT){
			printf("  wait in activate_r() !!\n");
			return;
		}
	}
	printf("  wait in dispatch() !!\n");
}

/******************************************************************************
 * 顼Ѵؿ
 ******************************************************************************/
/*
 * 쥮顼ߥϥɥ顼
 */
void
irregular_int_handler(void)
{
	if(runtsk){
		if(intnest > 1){
			syslog_1(LOG_EMERG, "Irregular Interrupt occured in tskid=%d !", TSKID(runtsk));
			kernel_exit();
		}
		else{
			syslog_1(LOG_ERROR, "Irregular Interrupt occured in tskid=%d  !", TSKID(runtsk));
			isus_tsk(TSKID(runtsk));
		}
	}
	else{
		syslog_0(LOG_EMERG, "Irregular Interrupt occured in Idle!");
		kernel_exit();
	}
}

/*
 * 쥮顼ץ
 */
void
irregular_ext_handler(VP p_excinf)
{
	UW pc = get_exception_pc(p_excinf);

	if(runtsk){
		if(exc_sense_context(p_excinf)){
			syslog_1(LOG_EMERG, "Irregular Exception occured in not task Context pc=0x%x !", pc);
			kernel_exit();
		}
		else{
			syslog_2(LOG_ERROR, "Irregular Exception occured in tskid=%d pc=0x%x !", TSKID(runtsk), pc);
			isus_tsk(TSKID(runtsk));
		}
	}
	else{
		syslog_1(LOG_EMERG, "Irregular Exception occured in Idle pc=0x%x !", pc);
		kernel_exit();
	}
}

