/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2005 by Ryosuke Takeuchi
 *                     GJ Business Division RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: stddev.c,v 1.1 2005/07/16 13:46:29 roi Exp $
 */

/* 
 *  TOPPERS/JSPѥ˥CPU¸ץࡥ
 *
 */

#include <t_services.h>
#include <s_services.h> 
#include <stdio.h>


#ifdef _SMALL_STDIO_
/******************************************************************************
 * ̾ɸϤ
 ******************************************************************************/

FILE _iob[4];
static ID   dummyid = CONSOLE_PORTID;
static ID * stdport = &dummyid;

/*
 *  ˥Σʸʸ
 */
static int
local_getc(void)
{
	char buf[2];

	serial_rea_dat(*stdport, buf, 1);
	return (int)buf[0];
}

/*
 *  ˥Σʸʸ
 */
static void
local_putc(int c)
{
	char buf[2];

	buf[0] = c;

	serial_wri_dat(*stdport, buf, 1);
}

/*
 *  ˥ʸʸ
 */
static int
local_puts(int len, char *s)
{
	return serial_wri_dat(*stdport, s, len);
}

/*
 *  ˥Υǡեå饷ʸ
 */
static int
local_flush()
{
	return 0;
}

/*
 *  ɸϴؿ
 */
int fputc(int c, FILE *st)
{
	if(c == '\n')
		st->_func_out('\r');
	st->_func_out(c);
	return 1;
}

/*
 *  ɸϴؿ
 */
int fgetc(FILE *st)
{
	return st->_func_in();
}

/*
 *  ɸʸϴؿ
 */
int puts(const char *st)
{
	return stdout->_func_outs(strlen(st), (char *)st);
}

/*
 *  ХåեΥեåؿ
 */
int fflush(FILE *st)
{
	if(st == NULL)
		return stdout->_func_flush(stdout);
	else
		return st->_func_flush(st);
}

/*
 *  ɸϽؿ
 */
void _setup_stdio(signed int *pport)
{
	int i;

	stdport = pport;
	for(i = 0 ; i < 3 ; i++){
		_iob[i]._file       = -1;
		_iob[i]._func_in    = local_getc;
		_iob[i]._func_out   = local_putc;
		_iob[i]._func_outs  = local_puts;
		_iob[i]._func_flush = local_flush;
		_iob[i]._dev        = 0;
	}
}

/*
 *  ɸѥȥ꡼Фؿ
 */
FILE *_get_stdio(int no)
{
	return &_iob[no];
}

#endif /* _SMALL_STDIO_ */

